#include <pspkernel.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include "pg.h"
#include "dialog.h"
#include "danzeff.h"

extern int bQuit;

extern u16 _menubmp[];
extern u16 _splashbmp[];
u16 *bBitmap = _menubmp;

void dlg_frame(const char *msg0, const char *msg1)
{
  int x, i;
    
  bltrect br = { 0, 0, 480, 255, 512, 256, _menubmp, 1, GE_TPSM_8888 };
  pgBitBltR(&br, 0, 17);

  // CACbCZA[CWBHBG
  if(msg0) mh_print(17, 17, msg0, WHITE);
//  pgDrawFrame(17,25,463,248,GREY);
//  pgDrawFrame(18,26,462,247,GREY);
  // Q@MlP>
  if(msg1) {
    x = (479-(strlen(msg1)*5))/2;
    for(i=0; msg1[i]; i++) if((msg1[i] & 0xf0) == 0x80) x-=5;
    mh_print(x, 271-16, msg1, WHITE);
  }
}

u8 GREY32[32] = {
  0x00, 0x10, 0x20, 0x30, 0x40, 0x50, 0x60, 0x70,
  0x80, 0x90, 0xa0, 0xb0, 0xc0, 0xd0, 0xe0, 0xf0,
  0xf0, 0xe0, 0xd0, 0xc0, 0xb0, 0xa0, 0x90, 0x80,
  0x70, 0x60, 0x50, 0x40, 0x30, 0x20, 0x10, 0x00,
};

int MessageBox(const char *msg, int type){
  int f=0, c;
  int MsgSel = 0;
  bltrect br = { 0, 0, 480, 255, 512, 256, _menubmp, 1, GE_TPSM_8888 };

  while(!bQuit) {

    readpad(0);

    if(new_pad & (PSP_CTRL_LEFT | PSP_CTRL_RIGHT)) MsgSel = !MsgSel;
    if(new_pad & (PSP_CTRL_CROSS | PSP_CTRL_CIRCLE)) { readpad(0); return MsgSel; }
    if((new_pad & (PSP_CTRL_SQUARE | PSP_CTRL_TRIANGLE)) && type) { readpad(0); return 0; }

    pgStartFrame();

    pgBitBltR(&br, 0, 17);

    mh_print(240-63, 271-15, " /  Enter   /  Back", BLACK);
    mh_print(240-64, 271-16, " /  Enter   /  Back", WHITE);

//    x = (479-(strlen(msg)*5))/2;
//    mh_print(x,97,msg, BLACK);
//    mh_print(x,96,msg, WHITE);

    f++;
    c = AY8(GREY32[f&0x1f], GREY32[f&0x1f]);

    if(type) {
      if(MsgSel) {
        pgFillBox(122, 122, 242, 146, c);
      } else {
        pgFillBox(248, 122, 368, 146, c);
      }

      mh_print(279, 126, "\tCancel", BLACK);
      mh_print(278, 125, "\tCancel", WHITE);
      mh_print(173, 126, "\tOk", BLACK);
      mh_print(172, 125, "\tOk", WHITE);
    } else {
      pgFillBox(204, 122, 276, 146, c);
      mh_print(231, 126, "\tOk", BLACK);
      mh_print(230, 125, "\tOk", WHITE);
    }

    mh_print(28,32,msg,WHITE);
    pgEndFrame();
  }
  readpad(0);
  return 0;
}

void PostProgressMessage(const char *msg, u16 curr, u16 max){
    u32 c=curr, m=max;
    bltrect br = { 0, 0, 480, 255, 512, 256, _splashbmp, 1, GE_TPSM_8888 };

    pgStartFrame();

    pgBitBltR(&br, 0, 17);
    mh_print(4,34,msg,WHITE);

    if(m) {
     pgDrawFrame(242, 34, 478, 50, GREY);
     pgFillBox(244, 36, 244+(232*c)/m, 48, WHITE);
    }

    pgEndFrame();
}

char Keys[2][6][13][16] = { {
{
 "Esc", "", "F1", "", "F2", "", "F3", "", "F4", "", "F5", "", "F6"
}, {
 "`", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "-", "="
}, {
 "q", "w", "e", "r", "t", "y", "u", "i", "o", "p", "[", "]", " Backspace"
}, {
 "a", "s", "d", "f", "g", "h", "j", "k", "l", ";", "'", "", "   Enter"
}, {
 "z", "x", "c", "v", "b", "n", "m", ",", ".", "/", "Shift", "", "  Delete"
}, {
 "Ctrl","", "Alt","", "Space","",  "",  "",  "Tab",  "", "\\", "", "   Abort"
}
 }, {
{
 "Esc", "", "F7", "", "F8", "", "F9", "", "F10", "", "F11", "", "F12"
}, {
 "~", "!", "@", "#", "$", "%", "^", "&", "*", "(", ")", "_", "+"
}, {
 "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", "{", "}", " Backspace"
}, {
 "A", "S", "D", "F", "G", "H", "J", "K", "L", ":", "\"", "", "   Enter"
}, {
 "Z", "X", "C", "V", "B", "N", "M", "<", ">", "?", "Shift", "", "  Delete"
}, {
 "Ctrl","", "Alt","", "Space","",  "",  "", "Tab", "", "|", "", "   Abort"
}
 } };

u8 Spacing[6][13] = { {
 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2
}, {
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
}, {
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3
}, {
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 3
}, {
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 0, 3
}, {
 2, 0, 2, 0, 4, 0, 0, 0, 2, 0, 1, 0, 3
} };

u8 KeyCodes[2][6][13] = { { {
 27,  0, 0xf1,  0, 0xf2,  0, 0xf3,  0, 0xf4,  0, 0xf5,  0, 0xf6
}, {
 '`', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '='
}, {
 'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '[', ']', 8
}, {
 'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', '\'', 0, 13
}, {
 'z', 'x', 'c', 'v', 'b', 'n', 'm', ',', '.', '/', 0xfe, 0, 127
}, {
 0xfd,  0, 0xf0,   0, ' ',   0,   0,   0,  '\t',  0, '\\', 0, 255
} }, { {
 27,  0, 0xf7,  0, 0xf8,  0, 0xf9,  0, 0xfa,  0, 0xfb,  0, 0xfc
}, {
 '~', '!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '_', '+'
}, {
 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '{', '}', 8
}, {
 'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', ':', '"',   0, 13
}, {
 'Z', 'X', 'C', 'V', 'B', 'N', 'M', '<', '>', '?', 0xfe,  0, 127
}, {
 0xfd,  0, 0xf0,   0, ' ',   0,   0,   0, '\t',  0, '|',  0, 255
} } };

int 
VKB_InputText(char *Banner, char *outbuffer, int len) 
{
  //int x, y;
  //int d=-1;
  int f=0;
  //int VKB_x = 0, VKB_y = 0;
  int VKB_s = 0;
  int VKB_Done = 0;
  //int shift = 0;
  char tbuf[512];
  char *obuf = tbuf+1;

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
  
  if(len>500) len = 500;
  
  tbuf[0] = '\t';
  memcpy(tbuf+1, outbuffer, len);
  tbuf[len] = 0;

  while(!VKB_Done && !bQuit) {
    f++;

    pgStartFrame();

    dlg_frame(Banner," /  Select");
    mh_print(32,42,tbuf, WHITE);
    mh_print(32+VKB_s*10,62,"\t^", RED);

    sceKernelDelayThread(1000); 

    danzeff_render();
    pgEndFrame();

    SceCtrlData c;
    sceCtrlPeekBufferPositive(&c, 1);

    int danzeff_key = danzeff_readInput(c);
    if (danzeff_key > DANZEFF_START) {
      if (danzeff_key >= ' ') {
        obuf[VKB_s++] = danzeff_key;
      } else
      if (danzeff_key == DANZEFF_DEL) {
        if(VKB_s) {
          strcpy(obuf + VKB_s-1, obuf + VKB_s);
          VKB_s--;
        }
      } else
      if (danzeff_key == DANZEFF_RIGHT) {
        VKB_s++;
      } else
      if (danzeff_key == DANZEFF_LEFT) {
        VKB_s--;
      } else
      if (danzeff_key == DANZEFF_DOWN) {
        VKB_Done=2;
      } else
      if (danzeff_key == DANZEFF_UP) {
        if(strlen(obuf)) {
          strcpy(obuf + VKB_s, obuf + VKB_s+1);
        }
      }

    } else 
    if (danzeff_key == DANZEFF_START ) {
      VKB_Done=1;
    } else 
    if (danzeff_key == DANZEFF_SELECT ) {
      VKB_Done=1;
    }

    if(VKB_s<0) VKB_s=0;
    int length = strlen(obuf);
    if(VKB_s>length) VKB_s=length;
  }

  memcpy(outbuffer, tbuf+1, len);

  return (VKB_Done==2);
}

int 
MsgPrintf(int type, char *fmt, ...) 
{
  va_list opt;
  
  char buff[2048];
  int bufsz;
  
  va_start(opt, fmt);
  bufsz = vsnprintf( buff, (size_t) sizeof(buff), fmt, opt);
  buff[bufsz] = 0;

  if(type==2) { 
    PostProgressMessage(buff, 0, 0);
    return 0;
  } else
    return MessageBox(buff, type);
}
